; 

;                 Build this with the "Project" menu using
;                       "Console Assemble and Link"

; 
    include \masm32\include\masm32rt.inc
    

    .686p                                   ; create 32 bit code
    
    .model flat, stdcall                    ; 32 bit memory model
    option casemap :none                    ; case sensitive
        .xmm
    ;include sse2.inc
    printf MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke crt_printf, cfm$(format), args
    ELSE
        invoke crt_printf, cfm$(format)
    ENDIF
    EXITM <>
ENDM

;==============================================================================

scanf MACRO format:REQ, arg:REQ
    invoke crt_scanf, cfm$(format), arg
    EXITM <>
ENDM

    ;*****************************************************
    ;M1*V1/M2=V2
    .data
    align 16
    M1  real4   3000.0,500.0,200.0,100.0 ;weight/s output from rocket engines
    M2  real4   3003000.0,10000.0,10000.0,10000.0 ;fullweight of rocket
    V1  real4   3000.0,4500.0,7500.0,7500.0 ;outlet speed m/s from rocket engine
    V2  real4   0.0,0.0,0.0,0.0             ;rocketspeed m/s
    ;drag
    FD  real4   0.0,0.0,0.0,0.0
    P   real4   1.2250 ;density
    ;v=V2
    CD  real4   0.25 ;wonder what a rocket drag coffience is?
    Area    real4   1.0
    C2      real4   0.5
    ;rocketarea cone approximation
    PI      real4   3.14 
    R       real4   10.0
    S       real4   11.6
    r8      real8   0.0
    CO      dd 1000
    Fgravity    real4   0.0
    gravity real4   9.82
    Fup real4   0.0

    .code                       

; 

start:                         
    fldpi
    fstp PI
    print chr$("Welcome to rocketscience calculation",13,10)
    ;scanf( "%lf", ADDR r8 )
    ;calculate rocketarea
    movss xmm0,PI
    mulss xmm0,R
    mulss xmm0,S
    movss Area,xmm0
@@l1:
    ;calculate action/reaction formula
    movss xmm0,M1
    mulss xmm0,V1
    movss Fup,xmm0
    divss xmm0,M2
    movss xmm1,V2
    addss xmm1,xmm0
    movss V2,xmm1
    movss xmm0,M2
    subss xmm0,M1
    movss M2,xmm0
    ;calculate airresistance
    ;FD=1/2*pv^2*CD*A
    mulss xmm1,xmm1
    mulss xmm1,P
    mulss xmm1,CD
    mulss xmm1,Area
    mulss xmm1,C2
    movss FD,xmm1
    ;calculate gravity
    movss xmm0,M2
    mulss xmm0,gravity
    movss Fgravity,xmm0
    ;movss xmm0,V2
    ;subss xmm0,gravity
    ;movss V2,xmm0

    print chr$("speed :")
    fld V2
    fstp r8
    printf( "\n\n%.16f\n\n", r8 )
    print chr$(13,10)
    print chr$("drag force :" )

    fld FD
    fstp r8
    printf( "\n\n%.16f\n\n", r8 )
    print chr$("thrust force :")
    fld Fup
    fstp r8
    printf( "\n\n%.16f\n\n", r8 )
        
    mov ecx,CO
    dec ecx
    mov CO,ecx
    .IF ecx>0 
        jmp @@l1
    .ENDIF

    
    
    
    inkey
    exit

; 

end start        
